PLM之家PLMHome

[原创视频] PLM之家-NX9.0 二次开发实例视频32 NXOpen C++创建拉伸特征

2014-5-4 19:59:01 20396 124

  [复制链接]
admin 发表于 2014-2-27 21:05:40 |阅读模式

admin 楼主

2014-2-27 21:05:40

请使用QQ关联注册PLM之家,学习更多关于内容,更多精彩原创视频供你学习!

您需要 登录 才可以下载或查看,没有帐号?注册

x
PLM之家-NX9.0 二次开发实例视频32 NXOpen C++创建拉伸特征

NXOpen C++创建拉伸特征

NXOpen C++创建拉伸特征

: \: }% Z5 N- `- Z8 W, D  |
内容:
1 i1 {3 k2 s0 t- r/ K/ L& s$ q& K通过草图创建拉伸操作; _# b, G1 r. `: k; P0 z1 d
目的:
9 T. R& U' b7 T! f4 u7 O在NX中,使用NXOpen C++可以很方便的进行JA的录制,草图的拉伸可以通过JA生成代码,此处拉伸草图的方向为草图的法相方向。需要用户输入拉伸的起始值和结束值。草图创建过程中主要是对section进行定义,在定义的时候需要考虑到选择意图selectionRule的定义。
7 @6 z4 R$ |1 y
2 E8 c9 A% n! D$ t# @
# G' `; l+ K8 z9 ^) }% X) n
关键代码分享:, I: [; M7 u! \

  1. 1 l( {; o1 y. |1 F- H: I4 M
  2. <font size="5">; N7 J4 H& ^1 N' [& I! ~: g
  3. </font>3 X7 `7 w$ [$ T7 b
  4. <font size="5">void lesson32_createExtrude::createExtrude(SkeTCh *sketch)
    0 f- m1 ~  i' F' K
  5. {# S" \! {( ~0 r9 _8 l% Q
  6. - H! u  q, p0 D) ~2 }* H9 T
  7.         Features::Feature *nullFeatures_Feature(NULL);
    " d! o3 J" e! [1 n! ?9 Y7 e' N* |
  8.         Features::ExtrudeBuilder *extrudeBuilder1;
    0 j$ L9 G7 S6 E; `
  9.     extrudeBuilder1 = workPart->Features()->CreateExtrudeBuilder(nullFeatures_Feature);* b' f; l9 O/ o! O
  10.         // set parameters
    & k: b. @% g6 @: ]

  11. & Z. j4 w, C6 J+ o* K7 _
  12.         // create section Start3 M$ v& w2 k: P# F/ _
  13.         Section * section;
    9 O  `6 K. v$ d; @% w
  14.         section = workPart->Sections()->CreateSection();
    ! g* N7 x. a/ m2 y( g
  15.         extrudeBuilder1->SetSection(section);
      F8 X# N/ r) Z; q
  16. 8 l4 k4 U# ], i# F% [% L" d
  17.         CurveFeatureRule *curveFeatureRule1;0 r0 {- M9 r& K; B
  18.         std::vector<Features::Feature *> Rulefeatures(1);
    1 o, J$ p' c! }- P9 i4 H4 g( D
  19.         Rulefeatures[0] = sketch->Feature();1 R0 }/ H  t2 p" {
  20.         curveFeatureRule1 = workPart->ScRuleFactory()->CreateRuleCurveFeature(Rulefeatures);; d) o' M1 _5 k, I+ j6 j1 v

  21. 1 K, r6 N( i4 Y  o$ L
  22.     std::vector<SelectionIntentRule *> rules(1);
    / `; x# q2 ]1 U" z4 p4 `7 u
  23.     rules[0] = curveFeatureRule1;3 d$ ]7 l" p; Z2 U3 X

  24. ) v( x* [0 |1 ]1 G$ y" o, A
  25.     NXObject *nullNXObject(NULL);
    2 ]) I" o" `$ }7 h7 X

  26. + V0 g+ J& S# y, N
  27.     Point3d helpPoint1(0, 0, 0);
    ' K& N+ i" ^( `7 r# \0 c

  28. 6 q9 [/ |; W3 @9 V$ V2 m/ t
  29.     section->AddToSection(rules, nullNXObject, nullNXObject, nullNXObject, helpPoint1, Section::ModeCreate, false);
    " o$ H0 m+ V; q1 S+ {
  30.         
    , F1 h2 V9 _8 B2 H7 U! w/ P5 R
  31.      
    - C% h/ `+ t7 k/ \; U3 o7 |
  32.         // create section End+ n+ ]. S: }4 Q& Q$ M/ n# s/ u

  33. # _' d" V, d% [) y; V7 L
  34.         Direction *direction;
    ( ?% O" T2 R2 Q( u+ A, H
  35.         direction = workPart->Directions()->CreateDirection(sketch,SenseForward,SmartObject::UpdateOptionWithinModeling);1 o4 U: q, a4 Z; E3 w5 \( W
  36.         extrudeBuilder1->SetDirection(direction);5 H& E& C) ^5 M  I9 |
  37. 2 z# b5 N5 L8 ?: `5 N1 F& H

  38. $ I# b+ e3 d0 s! T' T
  39.         // get the UI value
    - H- R: A, [' ?! f& c4 p

  40. ) s+ `: a2 v4 c( k3 J" {9 n6 D
  41.         double startValue = this->expExtrudeStart->GetProperties()->GetDouble("Value");5 o8 j& X, o( b  x! ~6 M% {
  42.         double endValue = this->expExtrudeEnd->GetProperties()->GetDouble("Value");
    " a+ U: o1 u# e% k
  43.          stringstream s_startValue,s_endValue;
    ' t8 e) W' {2 v( x3 ]+ K
  44.          s_startValue <<startValue;2 X* O# r# R& G& l  F% ]
  45.          s_endValue <<endValue;
    ) h5 B4 E9 u0 O" j2 `/ ?6 D, |
  46.         + ]9 F/ P& O  x0 P
  47.          extrudeBuilder1->Limits()->StartExtend()->SetValue(s_startValue.str());2 n) M' u( u- |
  48.         extrudeBuilder1->Limits()->EndExtend()->SetValue(s_endValue.str());- g5 j( Q9 G5 a$ b4 @) U) d. r
  49. 4 ]5 D1 X6 ~% z1 T
  50.         // commit feature
    - u7 W4 Y* u2 X/ O) A4 `/ T
  51.         extrudeBuilder1->CommitFeature();
    - ^6 e  P7 Q  A% r
  52.         extrudeBuilder1->Destroy();! m, G2 d3 z# l# {
  53.         5 h- r1 S' `9 k3 G5 B( H/ T
  54. }</font>
复制代码
4 g9 X- J6 x% x
% q7 l# g) c# N. y$ R6 V2 O4 \
- f! W+ T: [$ e3 C+ }8 Z+ ^

9 V- @& U( J( B  s8 \9 ?% q! l  N
# W! c1 v( E$ N( G/ j3 N" c# B
" M; a, j5 u* m+ H" N( [6 \

/ Y# G8 h7 t0 c1 K
, q' o) W: p! P: `1 r
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复

使用道具 举报

全部回复124

admin 发表于 2014-2-27 21:05:54

admin 沙发

2014-2-27 21:05:54

PLM之家NX9.0二次开发视频教程 32 NXOpen C++创建拉伸草图(1)项目创建 5 q( A5 j+ o" ]2 ?9 L6 ^, N6 Q- D, C' u ; B. G8 S) \* A5 p 4 k* u3 ~* e0 dPLM之家NX9.0二次开发视频教程 32 NXOpen C++创建拉伸草图(2)创建过程分析: A; J8 u8 k/ t5 A' C" r2 ` : z/ C$ l3 P( j1 F / ?( _0 U) t( n. U9 p+ S. _ 1 y6 V5 D! j2 A" E" yPLM之家NX9.0二次开发视频教程 32 NXOpen C++创建拉伸草图(3)拉伸创建完成 : F, J: n, N; X D7 @9 K * u4 R2 Q: V, B5 ^. k+ W8 W 8 k4 @2 b3 ]2 p: g. e# l ; E. k3 |% g8 `- v4 u. H: { 1 d+ Y6 V' W _ u 5 E4 D5 p4 f4 e: s+ P' J0 y# z" p! N3 @. e
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

admin 发表于 2014-4-12 13:14:50

admin 地板

2014-4-12 13:14:50

已经更新了
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

☠寶∞爺☠ 发表于 2014-4-21 11:06:31

☠寶∞爺☠ 6#

2014-4-21 11:06:31

voila ,so beautiful
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

东沟恋君 发表于 2014-4-23 19:01:19

东沟恋君 7#

2014-4-23 19:01:19

好视频,顶起来
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

C_X_J 发表于 2014-4-25 09:22:58

C_X_J 8#

2014-4-25 09:22:58

学习学习学习
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

七星笑侠/mg 发表于 2014-4-27 15:18:19

七星笑侠/mg 9#

2014-4-27 15:18:19

怎么没B语言呀。
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

★害虫★ 发表于 2014-5-4 19:59:01

★害虫★ 10#

2014-5-4 19:59:01

正在学习,学习。
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

发表回复

您需要登录后才可以回帖 登录 | 注册

返回列表 本版积分规则

用户组 : 管理员
邮   箱 :xduniverse@qq.com
手   机 :VIP用户可查看[申请]
Q   Q : 点击这里给我发消息
性别 : 就不告诉你
主页 :http://www.plmhome.com
个人介绍 :原西门子NX高级教务员,10多年NX培训,开发咨询,Teamcenter培训实施等

主题2237

帖子3470

积分65894

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 6 实现打开PLM之家

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 5 创建Tecnomatix

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 4 设置图标效果如

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 3 第一个hello plm

  • 官方文档,NX12 使用

    官方文档,NX12 使用 Python进行二次开发相关配

  • 关闭

    站长推荐上一条 /1 下一条

  • 发布新帖
  • 在线客服1
  • 在线客服2
  • 微信
  • 客户端
  • 返回顶部